#
# The Weather Tag
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472	ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

from DocumentTemplate.DT_String import String
from DocumentTemplate.DT_Util import *
from AccessControl.Role import RoleManager
import string, random, Globals, os, sys
from App.FindHomes import SOFTWARE_HOME
import cgi
import time
import Acquisition
import OFS

import regex
import types

class WeatherTag:
	name='weather'
	def __init__(self, blocks):
	
		args=blocks

		self.args=args=parse_let_params(args)
		theseArgs={}
		for i in range(len(args)):
			name,expr = args[i]
			theseArgs[name]=expr
			if expr[:1]=='"' and expr[-1:]=='"' and len(expr) > 1:
				# expr shorthand
				expr=expr[1:-1]
				try: args[i] = name, Eval(expr, expr_globals).eval
				except SyntaxError, v:
					m,(huh,l,c,src) = v
					raise ParseError, (
						'<strong>Expression (Python) Syntax error</strong>:'
						'\n<pre>\n%s\n</pre>\n' % v[0],
						'let')

	def findWeatherManagement(self, root):
		while root is not None:
			if hasattr(root, 'objectValues'):
				for o in root.objectValues():
					try:
						if ( hasattr(o, 'meta_type') and
							 o.meta_type=='Weather Management'):
							return o
					except:
						pass
			if hasattr(root, 'aq_parent'):
				root=root.aq_parent
			else:
				root=None
		return None
	
	def render(self, md):
		""" Show me Da Weather """
		metric=0		
		us=md.this

		d={};
		try:
			for name,expr in self.args:
				if type(expr) is type(''):
					try:
						d[name]=md[expr]
					except:
						d[name]=expr
				else:
					d[name]=expr(md)
		finally:
			pass

		if not d.has_key('show'):
			return ''

		if d.has_key('metric'):
			metric = 1
		
		_WeatherManager=self.findWeatherManagement(us)
		if not _WeatherManager:
			print "Couldn't find a Weather Manaqer"
			return ''

		weatherKey=d['show']
		if type(weatherKey) != types.ListType:
			return _WeatherManager.displayWeather(weatherKey, metric=metric, REQUEST=us.REQUEST)
		else:
			thisRender=''
			for c in weatherKey:
				foo=_WeatherManager.displayWeather(c, metric=metric)
				if foo:
					thisRender=thisRender+foo
			return thisRender

	__call__=render

def parse_let_params(text,
					 result=None,
					 tag='weather',
					 parmre=regex.compile(
	'\([\0- ]*\([^\0- =\"]+\)=\([^\0- =\"]+\)\)'),
					 qparmre=regex.compile(
	'\([\0- ]*\([^\0- =\"]+\)="\([^"]*\)\"\)'),
					 **parms):

	result=result or []

	if parmre.match(text) >= 0:
		name=parmre.group(2)
		value=parmre.group(3)
		l=len(parmre.group(1))
	elif qparmre.match(text) >= 0:
		name=qparmre.group(2)
		value='"%s"' % qparmre.group(3)
		l=len(qparmre.group(1))
	else:
		if not text or not strip(text): return result
		raise ParseError, ('invalid parameter: "%s"' % text, tag)
		
	result.append((name,value))

	text=strip(text[l:])
	if text: return apply(parse_let_params,(text,result,tag),parms)
	else: return result

String.commands['weather']=WeatherTag

		
