from ftplib import FTP
import string
import sys,os
import re

def dayToDate(advanceBy):
    dt=DateTime.now() + DateTime.RelativeDateTime(days=advanceBy)    
    today = DateTime.now()
 
    return str(dt)

globalWeather = {}
debug = {}

def chewLines(ftpLine):
    if re.search("^Sky conditions:",ftpLine) :
	globalWeather['SkyConditions']=re.sub("Sky conditions: (.*)","\\1",ftpLine);
	return
    if re.search("^Temperature:",ftpLine) :
	globalWeather['Temperature']=re.sub("Temperature:\s*(\-{0,1}[0-9.]{1,}).*","\\1",ftpLine)
	return
    if re.search("^Windchill:",ftpLine) :
	globalWeather['Chill']=re.sub("Windchill:\s*(\-{0,1}[0-9.]{1,}).*","\\1",ftpLine)
	return
    if re.search("^Dew Point:",ftpLine) :
	globalWeather['DewPnt']=re.sub("Dew Point:\s*(\-{0,1}[0-9.]{1,}).*","\\1",ftpLine)
	return
    if re.search("^Pressure (.*):",ftpLine) :
	globalWeather['Pressure']=re.sub("Pressure \(.*\):\s*([0-9.]{2,}).*","\\1",ftpLine)
	return
    if re.search("^Relative Humidity:",ftpLine) :
	globalWeather['Hum']=re.sub("Relative Humidity:\s*(\d{1,})\%.*","\\1",ftpLine)
	return
    if re.search("^Weather:",ftpLine):
	globalWeather['Weather']=re.sub("Weather: (.*)","\\1",ftpLine)
	return
    if re.search("^Visibility:",ftpLine):
	globalWeather['Visibility']=re.sub("Visibility: (.*):.*","\\1",ftpLine)
	return
    if re.search("^ob:",ftpLine) :
	globalWeather['codedMETAR']=re.sub("ob: (.*)","\\1",ftpLine)
	return
    return

def getWeather(ICAO):
    """ Fetch the Weather File """

    localWeather = {}
    varFlag=0
    windGroup=''
    varWindGroup=''
    gustFlag=0
    Direction=0
    Speed=0.0
    Speed1=0.0
    Speed2=0.0

    resultWeather = []
    globalWeather['ICAO']=ICAO
    host='weather.noaa.gov'
    fileName=ICAO+'.TXT'
    weatherDir='/data/observations/metar/decoded'

    ftp=FTP(host)
    userid = passwd = acct = ''
    ftp.login(userid,passwd,acct)
    ftp.sendcmd('CWD '+weatherDir)
    ftp.retrlines('RETR '+fileName, chewLines)
    ftp.quit()

    windGroup=globalWeather['codedMETAR']
    windGroup=re.sub("RML\s.*R","",windGroup)
    varWindGroup=windGroup
    if re.search(".*\s\w{3}\d{2,3}KT\s\d{3}V\d{3}\s.*",windGroup) :
	varWindGroup=re.sub(".*\s\w{3}\d{2,3}KT\s(\d{3}V\d{3})\s.*","\\1",windGroup)
	varFlag=1
    elif re.search(".*\s\w{3}\d{2,3}MPS\s\d{3}V\d{3}\s.*",windGroup) :
	varWindGroup=re.sub(".*\s\w{3}\d{2,3}G\d{2,3}KT\s(\d{2,3}V\d{2,3})\s.*","\\1",windGroup)
	varFlag=1
    elif re.search(".*\s\w{3}\d{2,3}G\d{2,3}MPS\s(\d{2,3}V\d{2,3})\s.*",windGroup) :
	varWindGroup=re.sub(".*\s\w{3}\d{2,3}G\d{2,3}MPS\s(\d{2,3}V\d{2,3})\s.*",windGroup)
	varFlag=1
    else:
	varWindGroup=""
	varFlag=0

    Direction1 = re.sub("(\d{3})V\d{3}","\\1",varWindGroup)
    Direction2 = re.sub("\d{3}V(\d{3})","\\1",varWindGroup)

    if re.search(".*\s\w{3}\d{2,3}KT\s.*",windGroup) :
	windGroup=re.sub(".*\s(\w{3}\d{2,3}KT)\s.*","\\1",windGroup)
	Direction=int(re.sub("(\w{3})\d{2,3}KT","\\1",windGroup))
	Speed = float(re.sub("\w{3}(\d{2,3})KT","\\1",windGroup))
    elif re.search(".*\s\w{3}\d{2,3}MPS\s.*",windGroup) :
	windGroup=re.sub(".*\s(\w{3}\d{2,3}G\d{2,3}KT)\s.*","\\1",windGroup)
	Direction=int(re.sub("(\w{3})\d{2,3}G\d{2,3}KT","\\1",windGroup))
	Speed1=float(re.sub("\w{3}(\d{2,3})G\d{2,3}KT",windGroup))
	Speed2=float(re.sub("\w{3}\d{2,3}G(\d{2,3})KT",windGroup))
	gustFlag=1
    elif re.search(".*\s\w{3}\d{2,3}G\d{2,3}MPS\s.*",windGroup) :
	windGroup=re.sub(".*\s(\w{3}\d{2,3}G\d{2,3}MPS)\s.*","\\1",windGroup)
	Direction=int(re.sub("(\w{3})\d{2,3}G\d{2,3}MPS","\\1",windGroup))
	Speed1=float(re.sub("\w{3}(\d{2,3})G\d{2,3}MPS","\\1",windGroup))
	Speed2=float(re.sub("\w{3}\d{2,3}G(\d{2,3})MPS","\\1",windGroup))
	Speed1 = Speed1 * 1.942
	Speed2 = Speed2 * 1.942
	gustFlag=1
    else:
	windGroup=''
    
    if re.search(ICAO+" \d{2}\d{2}Z",globalWeather['codedMETAR']) :
	universalTime=re.sub('.*'+ICAO+" (\d{2})(\d{2})Z .*","\\1:\\2",
			     globalWeather['codedMETAR'])
    else:
	universalTime='99:99'

    localWeather['StationInfo']=ICAO
    localWeather['SkyConditions']=globalWeather['SkyConditions']
    localWeather['UniversalTime']=universalTime
    localWeather['Temp']=globalWeather['Temperature']
    localWeather['DewPnt']=globalWeather['DewPnt']

    try:
	localWeather['Weather']=globalWeather['Weather']
    except:
	pass

    try:
	localWeather['Visibility']=globalWeather['Visibility']
    except:
	pass
    try:
	localWeather['Chill']=globalWeather['Chill']
    except:
	pass

    localWeather['Pressure']=globalWeather['Pressure']
    localWeather['Hum']=globalWeather['Hum']
    
    if(not Direction):
	localWeather['Direction']='-9999'
    elif (Direction == 'VRB'):
	localWeather['Direction']='999'
    elif (varFlag):
	localWeather['Direction']=-(Direction)
    else:
	localWeather['Direction']=Direction

    if(not windGroup):
	localWeather['WindSpeed']='-9999'
    elif (gustFlag):
	AvgSpeed = (Speed1 + Speed2) / 2.0
	AvgSpeed = AvgSpeed * 1.15155
	localWeather['WindSpeed']=str(-AvgSpeed)
    else:
	Speed = Speed * 1.5155
	localWeather['WindSpeed']=str(Speed)
    
    resultWeather.append(localWeather)
    return(resultWeather)

print dayToDate(1)


    
	
	
    
